# Class TileSublayerExtension

Extends the capabilities of an Esri Sublayer object.

#### Hierarchy (view full)

- ArcGISSublayerExtension<TileSublayerExtensionProperties>
  - TileSublayerExtension

#####
Index

### Constructors

constructor

### Properties

_effectiveFullExtent
_id
_itemType
_watchHandles
@eventTypes
iconUrl?
layerListSettings
onAddFeature?
onEditFeature?
queryService?
factory

### Accessors

_gdbVersion
canChangeDefinitionExpression
canChangeLabels
canChangeOpacity
canChangeRenderer
canChangeScale
canToggleVisibility
capabilities
effectiveFullExtent
effectiveMaxScale
effectiveMinScale
failureMode
featureActions
featureSettings
featureSourceActions
hasFeatures
hyperlinks
id
initialDefinitionExpression
initialRenderer
initialVisibility
isDestroyed
isEffectivelyVisible
isInitialized
itemType
layerExtension
parentSublayerExtension
relationships
renderer
requestHelper
schema
sublayer
sublayerExtensions
supportsPagination
supportsSublayers
taskSettings
title
visibilityMode

### Methods

_addAttachment
_addFeatures
_applySublayerProperties
_capabilities
_createFeatureSettings
_createHyperlinks
_createLayerListSettings
_createRelationships
_createRequestHelper
_createSchema
_createSublayer
_createSublayerExtension
_createSublayerExtensionCollection
_createSublayerRef
_createTaskSettings
_deleteAttachments
_deleteFeatures
_getAttachments
_getFeatures
_getSerializableProperties
_initializableChildCollections
_initializeChildren
_isRelationship
_isSupportedSublayer
_onDestroy
_onInitialize
_onSublayerAddedPostInitialize
_postInitialize
_serializeSublayer
_toPropertyDef
_updateFeatures
_watchSublayerProperties
addAttachment
addFeature
addFeatures
assignProperties
assignPropertiesAsync
deleteAttachments
deleteFeature
deleteFeatures
destroy
finishAssignProperties
getAttachments
getDefault
getDefaults
getFeature
getFeatures
getFullExtent
getSerializableProperties
initialize
toItemUri
toJSON
updateFeature
updateFeatures
create

##
Constructors

### constructor

- new TileSublayerExtension(properties?): TileSublayerExtension

- #### Parameters

  - `Optional` properties: TileSublayerExtensionProperties

  #### Returns TileSublayerExtension

  Inherited from ArcGISSublayerExtension.constructor

##
Properties

### `Protected`_effectiveFullExtent

_effectiveFullExtent: Extent

See mapping/_SublayerExtension!SublayerExtension.effectiveFullExtent.

Inherited from ArcGISSublayerExtension._effectiveFullExtent

### `Protected`_id

_id: string

The unique ID for this entity. Once set, this should never change.

Inherited from ArcGISSublayerExtension._id

### `Protected` `Readonly`_itemType

_itemType: string = ItemType.SUBLAYER_EXTENSION

The item type for this entity when it participates in an App.

Inherited from ArcGISSublayerExtension._itemType

### `Protected` `Readonly`_watchHandles

_watchHandles: ResourceHandle[] = []

A set of watch handles that get cleaned up when the class instance is destroyed.

Inherited from ArcGISSublayerExtension._watchHandles

### @eventTypes

@eventTypes: InitializableBaseEvents

#### Deprecated

Do not directly reference this property. Use EventNames and EventTypes helpers from @arcgis/core/Evented.

Inherited from ArcGISSublayerExtension.@eventTypes

### `Optional` iconUrl

iconUrl?: string

URL to an icon that represents this feature source.

Inherited from ArcGISSublayerExtension.iconUrl

### `Readonly` layerListSettings

layerListSettings: LayerListSettings

Settings that affect the behavior and presentation of the sublayer in the layer list.

Inherited from ArcGISSublayerExtension.layerListSettings

### `Optional` onAddFeature

onAddFeature?: Action

The action to be executed when a feature is added.

Inherited from ArcGISSublayerExtension.onAddFeature

### `Optional` onEditFeature

onEditFeature?: Action

The action to be executed when a feature is edited.

Inherited from ArcGISSublayerExtension.onEditFeature

### `Optional` queryService

queryService?: QueryService

An optional query service that the feature source can use to get features.

Inherited from ArcGISSublayerExtension.queryService

### `Static` factory

factory: SublayerExtensionFactory

The factory that will be used whenever a new sublayer extension needs to be created. Applications can supply their own factory to customize sublayer extension creation.

Inherited from ArcGISSublayerExtension.factory

##
Accessors

### `Protected`_gdbVersion

- get _gdbVersion(): string

- #### Returns string

  Inherited from ArcGISSublayerExtension._gdbVersion

### canChangeDefinitionExpression

- get canChangeDefinitionExpression(): boolean

- Determines whether the type of sublayer being extended supports changing its definition expression.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.canChangeDefinitionExpression

### canChangeLabels

- get canChangeLabels(): boolean

- Determines whether the type of sublayer being extended supports changing labels. Default is false.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.canChangeLabels

### canChangeOpacity

- get canChangeOpacity(): boolean

- Determines whether the type of sublayer being extended supports changing opacity. Sublayers belonging to tiled layers cannot have their opacity changed, for example. The default is true.

  #### Returns boolean

  Overrides ArcGISSublayerExtension.canChangeOpacity

### canChangeRenderer

- get canChangeRenderer(): boolean

- Determines whether the type of sublayer being extended supports changing its renderer.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.canChangeRenderer

### canChangeScale

- get canChangeScale(): boolean

- Determines whether the type of sublayer being extended supports changing Scale. Sublayers belonging to tiled layers cannot have their scale changed, for example. The default is true.

  #### Returns boolean

  Overrides ArcGISSublayerExtension.canChangeScale

### canToggleVisibility

- get canToggleVisibility(): boolean

- Determines whether the type of sublayer being extended supports toggling visibility. Sublayers belonging to tiled layers cannot have their visibilities toggled, for example. The default is true.

  #### Returns boolean

  Overrides ArcGISSublayerExtension.canToggleVisibility

### capabilities

- get capabilities(): QuerySourceCapabilities

- Capabilities of the feature source.

  #### Returns QuerySourceCapabilities

  Inherited from ArcGISSublayerExtension.capabilities

### effectiveFullExtent

- get effectiveFullExtent(): Extent

- The effective full extent of this sublayer extension.

  #### Returns Extent

  Inherited from ArcGISSublayerExtension.effectiveFullExtent

### effectiveMaxScale

- get effectiveMaxScale(): number

- The effective max scale for this sublayer extension.

  #### Returns number

  Inherited from ArcGISSublayerExtension.effectiveMaxScale

### effectiveMinScale

- get effectiveMinScale(): number

- The effective min scale for this sublayer extension.

  #### Returns number

  Inherited from ArcGISSublayerExtension.effectiveMinScale

### failureMode

- get failureMode(): FailureMode

- Determines how a parent object should handle initialization failure in this object. The default is "warn".

  - `"error"`: support/InitializeError!InitializeError is thrown.
  - `"warn"`: Message is logged and support/InitializableBase!InitializeWarningEvent is raised.
  - `"ignore"`: support/InitializableBase!InitializeWarningEvent is raised.

  #### Returns FailureMode

  Inherited from ArcGISSublayerExtension.failureMode

- set failureMode(value): void

- #### Parameters

  - value: FailureMode

  #### Returns void

  Inherited from ArcGISSublayerExtension.failureMode

### featureActions

- get featureActions(): Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

- A menu for actions specifically related to features from this source.

  #### Returns Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  Inherited from ArcGISSublayerExtension.featureActions

- set featureActions(value): void

- A menu for actions specifically related to features from this source.

  #### Parameters

  - value: Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  #### Returns void

  Inherited from ArcGISSublayerExtension.featureActions

### featureSettings

- get featureSettings(): FeatureSettings

- Default settings that apply to features originating from this source.

  #### Returns FeatureSettings

  Inherited from ArcGISSublayerExtension.featureSettings

### featureSourceActions

- get featureSourceActions(): Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

- A menu for actions specifically related to this source.

  #### Returns Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  Inherited from ArcGISSublayerExtension.featureSourceActions

- set featureSourceActions(value): void

- A menu for actions specifically related to this source.

  #### Parameters

  - value: Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

  #### Returns void

  Inherited from ArcGISSublayerExtension.featureSourceActions

### hasFeatures

- get hasFeatures(): boolean

- Determines whether this type of layer is capable of producing features.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.hasFeatures

### hyperlinks

- get hyperlinks(): Collection<Hyperlink>

- Hyperlinks associated with the feature source.

  #### Returns Collection<Hyperlink>

  Inherited from ArcGISSublayerExtension.hyperlinks

### id

- get id(): string

- The unique ID for this entity.

  #### Returns string

  Inherited from ArcGISSublayerExtension.id

### initialDefinitionExpression

- get initialDefinitionExpression(): string

- String value containing the initial definition expression configured on the layer.

  #### Returns string

  Inherited from ArcGISSublayerExtension.initialDefinitionExpression

### initialRenderer

- get initialRenderer(): Renderer

- A clone of the initial renderer, if any, that the ESRI layer uses to display data on the map.

  #### Returns Renderer

  Inherited from ArcGISSublayerExtension.initialRenderer

### initialVisibility

- get initialVisibility(): boolean

- Indicates the initial layer visibility.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.initialVisibility

### isDestroyed

- get isDestroyed(): boolean

- See support/InitializableBase!Initializable.isDestroyed.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.isDestroyed

### isEffectivelyVisible

- get isEffectivelyVisible(): boolean

- The effective visibility for this sublayer extension.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.isEffectivelyVisible

### isInitialized

- get isInitialized(): boolean

- See support/InitializableBase!Initializable.isInitialized.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.isInitialized

### itemType

- get itemType(): string

- The item type for this entity when it participates in an App.

  #### Returns string

  Inherited from ArcGISSublayerExtension.itemType

### layerExtension

- get layerExtension(): TileLayerExtension

- The layer extension that this sublayer extension belongs to.

  #### Returns TileLayerExtension

  Overrides ArcGISSublayerExtension.layerExtension

### parentSublayerExtension

- get parentSublayerExtension(): SublayerExtension<SublayerExtensionProperties>

- The sublayer extension that this sublayer extension belongs to.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from ArcGISSublayerExtension.parentSublayerExtension

### relationships

- get relationships(): Collection<Relationship>

- Relationships to other feature sources.

  #### Returns Collection<Relationship>

  Inherited from ArcGISSublayerExtension.relationships

### renderer

- get renderer(): RendererUnion

- The renderer, if any, that the ESRI sublayer uses to display data on the map.

  #### Returns RendererUnion

  Inherited from ArcGISSublayerExtension.renderer

### requestHelper

- get requestHelper(): ArcGISRequestHelper

- The utilities/RequestHelper!RequestHelper to use when making requests to external services. If not specified, a default implementation will be used.

  #### Returns ArcGISRequestHelper

  Inherited from ArcGISSublayerExtension.requestHelper

- set requestHelper(value): void

- #### Parameters

  - value: ArcGISRequestHelper

  #### Returns void

  Inherited from ArcGISSublayerExtension.requestHelper

### schema

- get schema(): Schema

- Metadata about features originating from this source, such as fields, domains, and geometry type.

  #### Returns Schema

  Inherited from ArcGISSublayerExtension.schema

### sublayer

- get sublayer(): Sublayer

- The sublayer that is being extended.

  #### Returns Sublayer

  Inherited from ArcGISSublayerExtension.sublayer

### sublayerExtensions

- get sublayerExtensions(): ArcGISSublayerExtensionCollection<this>

- The sublayer extensions associated with each sublayer of this sublayer.

  #### Returns ArcGISSublayerExtensionCollection<this>

  Overrides ArcGISSublayerExtension.sublayerExtensions

### supportsPagination

- get supportsPagination(): boolean

- Whether or not the associate sublayer supports pagination. This affects if we can set maxResults as an option when querying the layer.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.supportsPagination

### supportsSublayers

- get supportsSublayers(): boolean

- Determines whether this type of sublayer is capable of having sublayers.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension.supportsSublayers

### taskSettings

- get taskSettings(): TaskSettings

- Settings that affect whether a feature source participates in various tasks that are performed on a map.

  #### Returns TaskSettings

  Inherited from ArcGISSublayerExtension.taskSettings

### title

- get title(): string

- See data/FeatureSource!FeatureSource.title.

  #### Returns string

  Inherited from ArcGISSublayerExtension.title

### visibilityMode

- get visibilityMode(): GroupLayerVisibilityMode

- Indicates how to manage the visibility of the children layers.

  #### Returns GroupLayerVisibilityMode

  Inherited from ArcGISSublayerExtension.visibilityMode

- set visibilityMode(value): void

- #### Parameters

  - value: GroupLayerVisibilityMode

  #### Returns void

  Inherited from ArcGISSublayerExtension.visibilityMode

##
Methods

### `Protected`_addAttachment

- _addAttachment(feature, attachment): Promise<Attachment>

- Called to add an attachment to a feature. Subclasses must override this if they support feature attachments.

  #### Parameters

  - feature: Feature

    The feature to add the attachment to.

  - attachment: AttachmentProperties | Attachment | File

    The attachment to add to the feature.

  #### Returns Promise<Attachment>

  Inherited from ArcGISSublayerExtension._addAttachment

### `Protected`_addFeatures

- _addFeatures(features, options?): Promise<void>

- Called to add new features. Subclasses must override this if they support adding features.

  #### Parameters

  - features: Iterable<Feature, any, any>

    The features to add.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._addFeatures

### `Protected`_applySublayerProperties

- _applySublayerProperties(properties, sublayer): Promise<void>

- Called to apply properties to the sublayer for this sublayer extension.

  #### Parameters

  - properties: ArcGISSublayerProperties
  - sublayer: Sublayer

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._applySublayerProperties

### `Protected`_capabilities

- _capabilities(): QuerySourceCapabilities

- The capabilities of the feature source.

  #### Returns QuerySourceCapabilities

  Inherited from ArcGISSublayerExtension._capabilities

### `Protected`_createFeatureSettings

- _createFeatureSettings(): FeatureSettings

- Called to create the data/FeatureSettings!FeatureSettings for this feature source.

  #### Returns FeatureSettings

  Inherited from ArcGISSublayerExtension._createFeatureSettings

### `Protected`_createHyperlinks

- _createHyperlinks(): Collection<Hyperlink>

- Called to create the Hyperlink collection for this feature source.

  #### Returns Collection<Hyperlink>

  Inherited from ArcGISSublayerExtension._createHyperlinks

### `Protected`_createLayerListSettings

- _createLayerListSettings(properties?): LayerListSettings

- Called to create the mapping/support/LayerListSettings!LayerListSettings for this sublayer extension.

  #### Parameters

  - `Optional` properties: LayerListSettingsProperties

    Properties used to initialize the layer list settings.

  #### Returns LayerListSettings

  Inherited from ArcGISSublayerExtension._createLayerListSettings

### `Protected`_createRelationships

- _createRelationships(): Collection<Relationship>

- Called to create the data/_Relationship!Relationship collection for this feature source.

  #### Returns Collection<Relationship>

  Inherited from ArcGISSublayerExtension._createRelationships

### `Protected`_createRequestHelper

- _createRequestHelper(): ArcGISRequestHelper

- #### Returns ArcGISRequestHelper

  #### Inherit Doc

  Inherited from ArcGISSublayerExtension._createRequestHelper

### `Protected`_createSchema

- _createSchema(): Schema

- Called to create the data/Schema!Schema for this feature source.

  #### Returns Schema

  Inherited from ArcGISSublayerExtension._createSchema

### `Protected`_createSublayer

- _createSublayer(properties): Promise<Sublayer>

- Called to create the sublayer for this sublayer extension.

  #### Parameters

  - properties: ArcGISSublayerProperties

  #### Returns Promise<Sublayer>

  Inherited from ArcGISSublayerExtension._createSublayer

### `Protected`_createSublayerExtension

- _createSublayerExtension(properties?): TileSublayerExtension

- Called to create a child sublayer extension.

  #### Parameters

  - `Optional` properties: TileSublayerExtensionProperties

    Properties used to initialize the sublayer extension.

  #### Returns TileSublayerExtension

  Overrides ArcGISSublayerExtension._createSublayerExtension

### `Protected`_createSublayerExtensionCollection

- _createSublayerExtensionCollection(): SubSublayerExtensionCollection

- Called to create the mapping/support/_SublayerExtensionCollection!SublayerExtensionCollection for this sublayer extension.

  #### Returns SubSublayerExtensionCollection

  Inherited from ArcGISSublayerExtension._createSublayerExtensionCollection

### `Protected`_createSublayerRef

- _createSublayerRef(): SublayerProperties

- Creates a $ref for the this sublayer extension's sublayer.

  #### Returns SublayerProperties

  Inherited from ArcGISSublayerExtension._createSublayerRef

### `Protected`_createTaskSettings

- _createTaskSettings(): TaskSettings

- Called to create the data/TaskSettings!TaskSettings for this feature source.

  #### Returns TaskSettings

  Inherited from ArcGISSublayerExtension._createTaskSettings

### `Protected`_deleteAttachments

- _deleteAttachments(feature, attachments): Promise<void>

- Called to remove attachments from a feature. Subclasses must override this if they support feature attachments.

  #### Parameters

  - feature: Feature

    The feature to delete attachments from.

  - attachments: (string | Attachment)[]

    The attachments or the IDs of the attachments to delete.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._deleteAttachments

### `Protected`_deleteFeatures

- _deleteFeatures(ids, options?): Promise<void>

- Called to delete features. Subclasses must override this if they support deleting features.

  #### Parameters

  - ids: string[]

    The IDs of the features to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._deleteFeatures

### `Protected`_getAttachments

- _getAttachments(feature): Promise<Attachment[]>

- Called to retrieve attachments for a feature. Subclasses must override this if they support feature attachments.

  #### Parameters

  - feature: Feature

    The feature to get attachments for.

  #### Returns Promise<Attachment[]>

  Inherited from ArcGISSublayerExtension._getAttachments

### `Protected`_getFeatures

- _getFeatures(ids, options?): AsyncIterable<Feature, any, any>

- Called to retrieve features. Subclasses must override this if they support querying for features.

  #### Parameters

  - ids: string[]

    The unique IDs of features to retrieve.

  - `Optional` options: FeatureReadOptions

    Options that control what gets returned.

  #### Returns AsyncIterable<Feature, any, any>

  Inherited from ArcGISSublayerExtension._getFeatures

### `Protected`_getSerializableProperties

- _getSerializableProperties(): PropertyDefs<TileSublayerExtensionProperties>

- The property keys and their metadata that are used to implement serializing and deserializing the class instance.

  #### Returns PropertyDefs<TileSublayerExtensionProperties>

  Overrides ArcGISSublayerExtension._getSerializableProperties

### `Protected`_initializableChildCollections

- _initializableChildCollections(): IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

- Collections of child items to initialize. Items that fail to initialize are removed from the collection.

  #### Returns IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

  Inherited from ArcGISSublayerExtension._initializableChildCollections

### `Protected`_initializeChildren

- _initializeChildren(): Promise<void>

- Initializes child entities.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._initializeChildren

### `Protected`_isRelationship

- _isRelationship(relationship): boolean

- #### Parameters

  - relationship: Relationship | RelationshipProperties

  #### Returns boolean

  Inherited from ArcGISSublayerExtension._isRelationship

### `Protected`_isSupportedSublayer

- _isSupportedSublayer(sublayer): boolean

- Determines whether the sublayer is of the right type for the type of sublayer extension.

  #### Parameters

  - sublayer: SublayerLike

    The sublayer to validate.

  #### Returns boolean

  Inherited from ArcGISSublayerExtension._isSupportedSublayer

### `Protected`_onDestroy

- _onDestroy(): Promise<void>

- Called to perform cleanup. Subclasses should override this method rather than destroy() to perform custom cleanup.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._onDestroy

### `Protected`_onInitialize

- _onInitialize(): Promise<void>

- Called to perform initialization of the support/InitializableBase!InitializableBase. Subclasses should override this method rather than initialize() to perform custom initialization.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._onInitialize

### `Protected` `Readonly`_onSublayerAddedPostInitialize

- _onSublayerAddedPostInitialize(sublayerX): Promise<void>

- A callback executed when a sublayer is added as a child of the LayerExtension, after the LayerExtension has been initialized.

  #### Parameters

  - sublayerX: SublayerExtension<SublayerExtensionProperties>

    The sublayer that was added.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._onSublayerAddedPostInitialize

### `Protected`_postInitialize

- _postInitialize(): Promise<void>

- Called after normal initialization. Note: Child items are initialized before this is called.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._postInitialize

### `Protected`_serializeSublayer

- _serializeSublayer(sublayer): ArcGISSublayerProperties

- Serializes a sublayer.

  #### Parameters

  - sublayer: Sublayer

    The sublayer to serialize.

  #### Returns ArcGISSublayerProperties

  Inherited from ArcGISSublayerExtension._serializeSublayer

### `Protected`_toPropertyDef

- _toPropertyDef<T>(def): PropertyDef<T>

- Converts the value to a PropertyDef object.

  #### Type Parameters

  - T

  #### Parameters

  - def: PropertyDefSerializeMode | PropertyDefSerializeMode[] | PropertyDef<T>

    The value to convert.

  #### Returns PropertyDef<T>

  Inherited from ArcGISSublayerExtension._toPropertyDef

### `Protected`_updateFeatures

- _updateFeatures(features, options?): Promise<void>

- Called to update features. Subclasses must override this if they support updating features.

  #### Parameters

  - features: Iterable<Feature, any, any>

    The feature to update.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension._updateFeatures

### `Protected`_watchSublayerProperties

- _watchSublayerProperties(): void

- Watches for changes on sublayer properties.

  #### Returns void

  Inherited from ArcGISSublayerExtension._watchSublayerProperties

### addAttachment

- addAttachment(feature, attachment): Promise<Attachment>

- Adds an attachment to a feature.

  #### Parameters

  - feature: Feature

    The feature to add the attachment to.

  - attachment: AttachmentProperties | Attachment | File

    The attachment to add to the feature.

  #### Returns Promise<Attachment>

  Inherited from ArcGISSublayerExtension.addAttachment

### addFeature

- addFeature(feature, _options?): Promise<void>

- Adds a new feature to the source. If the source does not support adding features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - feature: Feature

    The feature to add.

  - `Optional`_options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.addFeature

### addFeatures

- addFeatures(features, options?): Promise<void>

- Adds a set of features to the source. If the source does not support adding features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - features: FeatureSet

    The features to add.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are saved.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.addFeatures

### assignProperties

- assignProperties(properties): void

- #### Parameters

  - properties: Partial<TileSublayerExtensionProperties>

  #### Returns void

  #### Inherit Doc

  Inherited from ArcGISSublayerExtension.assignProperties

### assignPropertiesAsync

- assignPropertiesAsync(properties): Promise<void>

- #### Parameters

  - properties: Partial<TileSublayerExtensionProperties>

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from ArcGISSublayerExtension.assignPropertiesAsync

### deleteAttachments

- deleteAttachments(feature, attachments): Promise<void>

- Deletes attachments from a feature.

  #### Parameters

  - feature: Feature

    The feature to delete attachments from.

  - attachments: (string | Attachment)[]

    The attachments or the IDs of the attachments to delete from the feature.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.deleteAttachments

### deleteFeature

- deleteFeature(id, options?): Promise<void>

- Deletes a feature from its source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - id: string

    The ID of the feature to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.deleteFeature

- deleteFeature(feature, options?): Promise<void>

- Deletes a feature from its source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - feature: Feature

    The feature to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.deleteFeature

### deleteFeatures

- deleteFeatures(ids, options?): Promise<void>

- Deletes features from their source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - ids: Iterable<string, any, any>

    The IDs of the features to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.deleteFeatures

- deleteFeatures(features, options?): Promise<void>

- Deletes features from their source. If the source does not support deleting features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - features: Iterable<Feature, any, any>

    The features to delete.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are deleted.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.deleteFeatures

### destroy

- destroy(): Promise<void>

- A clean-up function that should get called whenever the item is disposed of.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.destroy

### finishAssignProperties

- finishAssignProperties(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from ArcGISSublayerExtension.finishAssignProperties

### getAttachments

- getAttachments(feature): Promise<Attachment[]>

- Gets any attachments associated with a feature.

  #### Parameters

  - feature: Feature

    The feature to get attachments for.

  #### Returns Promise<Attachment[]>

  Inherited from ArcGISSublayerExtension.getAttachments

### getDefault

- getDefault<K>(key): TileSublayerExtensionProperties[K]

- #### Type Parameters

  - K extends keyof TileSublayerExtensionProperties

  #### Parameters

  - key: K

  #### Returns TileSublayerExtensionProperties[K]

  #### Inherit Doc

  Inherited from ArcGISSublayerExtension.getDefault

### getDefaults

- getDefaults(): TileSublayerExtensionProperties

- #### Returns TileSublayerExtensionProperties

  #### Inherit Doc

  Inherited from ArcGISSublayerExtension.getDefaults

### getFeature

- getFeature(id, options?): Promise<Feature>

- Gets a feature by ID. If no such feature exists, the promise is rejected with an instance of NotFoundError.

  #### Parameters

  - id: string

    The ID of the feature to retrieve.

  - `Optional` options: FeatureReadOptions

    Additional options that control how the feature is retrieved.

  #### Returns Promise<Feature>

  Inherited from ArcGISSublayerExtension.getFeature

### getFeatures

- getFeatures(ids, options?): AsyncIterable<Feature, any, any>

- Gets a set of features by their IDs.

  #### Parameters

  - ids: string[]

    The IDs of the features to retrieve.

  - `Optional` options: FeatureReadOptions

    Additional Options that control how the features are retrieved.

  #### Returns AsyncIterable<Feature, any, any>

  Inherited from ArcGISSublayerExtension.getFeatures

### getFullExtent

- getFullExtent(): Extent

- Returns the full extent of the source that contains all included features.

  #### Returns Extent

  Inherited from ArcGISSublayerExtension.getFullExtent

### getSerializableProperties

- getSerializableProperties(serializeMode?): PropertyDefs<TileSublayerExtensionProperties>

- Returns the serializable properties.

  #### Parameters

  - `Optional` serializeMode: SerializeMode

    Optional. If specified, only properties that support the given serialization mode will be returned.

  #### Returns PropertyDefs<TileSublayerExtensionProperties>

  Inherited from ArcGISSublayerExtension.getSerializableProperties

### initialize

- initialize(): Promise<void>

- Initializes the item.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.initialize

### toItemUri

- toItemUri(): string

- Creates an item:// URI reference to this entity.

  #### Returns string

  Inherited from ArcGISSublayerExtension.toItemUri

### toJSON

- toJSON(serializeMode?): TileSublayerExtensionProperties

- #### Parameters

  - serializeMode: SerializeMode = "all"

  #### Returns TileSublayerExtensionProperties

  #### Inherit Doc

  Inherited from ArcGISSublayerExtension.toJSON

### updateFeature

- updateFeature(feature, _options?): Promise<void>

- Saves changes to an existing feature. If the source does not support updating features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - feature: Feature

    The feature to update.

  - `Optional`_options: FeatureWriteOptions

    Additional options that control how the feature is saved.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.updateFeature

### updateFeatures

- updateFeatures(features, options?): Promise<void>

- Saves changes to a existing features. If the source does not support updating features, then an InvalidOperationError will be thrown (see capabilities).

  #### Parameters

  - features: FeatureSet

    The features to update.

  - `Optional` options: FeatureWriteOptions

    Additional options that control how the features are saved.

  #### Returns Promise<void>

  Inherited from ArcGISSublayerExtension.updateFeatures

### `Static` create

- create(properties): SublayerExtension<SublayerExtensionProperties>

- Creates the appropriate subclass of mapping/_SublayerExtension!SublayerExtension based on the supplied properties. Applications can customize the default creation behavior by supplying a custom factory object (see mapping/_SublayerExtension!SublayerExtension.factory).

  #### Parameters

  - properties: SublayerExtensionProperties

    The sublayer extension properties.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from ArcGISSublayerExtension.create